//
// Copyright 2020 FoxyUtils ehf. All rights reserved.
//
// This is a commercial product and requires a license to operate.
// A trial license can be obtained at https://unidoc.io
//
// DO NOT EDIT: generated by unitwist Go source code obfuscator.
//
// Use of this source code is governed by the UniDoc End User License Agreement
// terms that can be accessed at https://unidoc.io/eula/

// Package fdf provides support for loading form field data from Form Field Data (FDF) files.
package fdf ;import (_f "bufio";_gf "bytes";_ec "encoding/hex";_e "errors";_cb "fmt";_cgg "github.com/unidoc/unipdf/v3/common";_bf "github.com/unidoc/unipdf/v3/core";_b "io";_cg "os";_cd "regexp";_a "sort";_d "strconv";_c "strings";);

// FieldValues implements interface model.FieldValueProvider.
// Returns a map of field names to values (PdfObjects).
func (fdf *Data )FieldValues ()(map[string ]_bf .PdfObject ,error ){_ga ,_ccc :=fdf .FieldDictionaries ();if _ccc !=nil {return nil ,_ccc ;};var _bd []string ;for _cbb :=range _ga {_bd =append (_bd ,_cbb );};_a .Strings (_bd );_agf :=map[string ]_bf .PdfObject {};
for _ ,_ab :=range _bd {_ca :=_ga [_ab ];_gb :=_bf .TraceToDirectObject (_ca .Get ("\u0056"));_agf [_ab ]=_gb ;};return _agf ,nil ;};func (_gbbg *fdfParser )parseArray ()(*_bf .PdfObjectArray ,error ){_efb :=_bf .MakeArray ();_gbbg ._dd .ReadByte ();for {_gbbg .skipSpaces ();
_cccb ,_dbg :=_gbbg ._dd .Peek (1);if _dbg !=nil {return _efb ,_dbg ;};if _cccb [0]==']'{_gbbg ._dd .ReadByte ();break ;};_ggg ,_dbg :=_gbbg .parseObject ();if _dbg !=nil {return _efb ,_dbg ;};_efb .Append (_ggg );};return _efb ,nil ;};var _bdf =_cd .MustCompile ("\u0025F\u0044F\u002d\u0028\u005c\u0064\u0029\u005c\u002e\u0028\u005c\u0064\u0029");


// Load loads FDF form data from `r`.
func Load (r _b .ReadSeeker )(*Data ,error ){_ac ,_ed :=_cfcg (r );if _ed !=nil {return nil ,_ed ;};_ef ,_ed :=_ac .Root ();if _ed !=nil {return nil ,_ed ;};_cga ,_aa :=_bf .GetArray (_ef .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));if !_aa {return nil ,_e .New ("\u0066\u0069\u0065\u006c\u0064\u0073\u0020\u006d\u0069s\u0073\u0069\u006e\u0067");
};return &Data {_ag :_cga ,_af :_ef },nil ;};func (_gdg *fdfParser )parseBool ()(_bf .PdfObjectBool ,error ){_ged ,_da :=_gdg ._dd .Peek (4);if _da !=nil {return _bf .PdfObjectBool (false ),_da ;};if (len (_ged )>=4)&&(string (_ged [:4])=="\u0074\u0072\u0075\u0065"){_gdg ._dd .Discard (4);
return _bf .PdfObjectBool (true ),nil ;};_ged ,_da =_gdg ._dd .Peek (5);if _da !=nil {return _bf .PdfObjectBool (false ),_da ;};if (len (_ged )>=5)&&(string (_ged [:5])=="\u0066\u0061\u006cs\u0065"){_gdg ._dd .Discard (5);return _bf .PdfObjectBool (false ),nil ;
};return _bf .PdfObjectBool (false ),_e .New ("\u0075n\u0065\u0078\u0070\u0065c\u0074\u0065\u0064\u0020\u0062o\u006fl\u0065a\u006e\u0020\u0073\u0074\u0072\u0069\u006eg");};func _bdd (_cgf string )(_bf .PdfObjectReference ,error ){_cgge :=_bf .PdfObjectReference {};
_gce :=_fea .FindStringSubmatch (_cgf );if len (_gce )< 3{_cgg .Log .Debug ("\u0045\u0072\u0072or\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065");return _cgge ,_e .New ("\u0075n\u0061\u0062\u006c\u0065 \u0074\u006f\u0020\u0070\u0061r\u0073e\u0020r\u0065\u0066\u0065\u0072\u0065\u006e\u0063e");
};_bggg ,_fdf :=_d .Atoi (_gce [1]);if _fdf !=nil {_cgg .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0070a\u0072\u0073\u0069n\u0067\u0020\u006fb\u006a\u0065c\u0074\u0020\u006e\u0075\u006d\u0062e\u0072 '\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006e\u0075\u006d\u0020\u003d\u0020\u0030",_gce [1]);
return _cgge ,nil ;};_cgge .ObjectNumber =int64 (_bggg );_bfc ,_fdf :=_d .Atoi (_gce [2]);if _fdf !=nil {_cgg .Log .Debug ("\u0045\u0072r\u006f\u0072\u0020\u0070\u0061r\u0073\u0069\u006e\u0067\u0020g\u0065\u006e\u0065\u0072\u0061\u0074\u0069\u006f\u006e\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0027\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u0067\u0065\u006e\u0020\u003d\u0020\u0030",_gce [2]);
return _cgge ,nil ;};_cgge .GenerationNumber =int64 (_bfc );return _cgge ,nil ;};func (_fa *fdfParser )skipSpaces ()(int ,error ){_fde :=0;for {_dg ,_fac :=_fa ._dd .ReadByte ();if _fac !=nil {return 0,_fac ;};if _bf .IsWhiteSpace (_dg ){_fde ++;}else {_fa ._dd .UnreadByte ();
break ;};};return _fde ,nil ;};func (_bfg *fdfParser )readComment ()(string ,error ){var _gff _gf .Buffer ;_ ,_ada :=_bfg .skipSpaces ();if _ada !=nil {return _gff .String (),_ada ;};_bbg :=true ;for {_bfa ,_db :=_bfg ._dd .Peek (1);if _db !=nil {_cgg .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_db .Error ());
return _gff .String (),_db ;};if _bbg &&_bfa [0]!='%'{return _gff .String (),_e .New ("c\u006f\u006d\u006d\u0065\u006e\u0074 \u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0073\u0074a\u0072\u0074\u0020w\u0069t\u0068\u0020\u0025");};_bbg =false ;if (_bfa [0]!='\r')&&(_bfa [0]!='\n'){_ecg ,_ :=_bfg ._dd .ReadByte ();
_gff .WriteByte (_ecg );}else {break ;};};return _gff .String (),nil ;};var _bbf =_cd .MustCompile ("\u0025\u0025\u0045O\u0046");var _dc =_cd .MustCompile ("\u005e\u005b\u005c\u002b\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d9\u002e\u005d\u002b\u0029");
func (_cdg *fdfParser )readAtLeast (_agb []byte ,_fd int )(int ,error ){_aaa :=_fd ;_ba :=0;_bc :=0;for _aaa > 0{_fe ,_fg :=_cdg ._dd .Read (_agb [_ba :]);if _fg !=nil {_cgg .Log .Debug ("\u0045\u0052\u0052O\u0052\u0020\u0046\u0061i\u006c\u0065\u0064\u0020\u0072\u0065\u0061d\u0069\u006e\u0067\u0020\u0028\u0025\u0064\u003b\u0025\u0064\u0029\u0020\u0025\u0073",_fe ,_bc ,_fg .Error ());
return _ba ,_e .New ("\u0066\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065a\u0064\u0069\u006e\u0067");};_bc ++;_ba +=_fe ;_aaa -=_fe ;};return _ba ,nil ;};

// LoadFromPath loads FDF form data from file path `fdfPath`.
func LoadFromPath (fdfPath string )(*Data ,error ){_ge ,_eb :=_cg .Open (fdfPath );if _eb !=nil {return nil ,_eb ;};defer _ge .Close ();return Load (_ge );};func (_dbf *fdfParser )parseName ()(_bf .PdfObjectName ,error ){var _eae _gf .Buffer ;_cbc :=false ;
for {_egb ,_cgd :=_dbf ._dd .Peek (1);if _cgd ==_b .EOF {break ;};if _cgd !=nil {return _bf .PdfObjectName (_eae .String ()),_cgd ;};if !_cbc {if _egb [0]=='/'{_cbc =true ;_dbf ._dd .ReadByte ();}else if _egb [0]=='%'{_dbf .readComment ();_dbf .skipSpaces ();
}else {_cgg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020N\u0061\u006d\u0065\u0020\u0073\u0074\u0061\u0072\u0074\u0069\u006e\u0067\u0020w\u0069\u0074\u0068\u0020\u0025\u0073\u0020(\u0025\u0020\u0078\u0029",_egb ,_egb );return _bf .PdfObjectName (_eae .String ()),_cb .Errorf ("\u0069n\u0076a\u006c\u0069\u0064\u0020\u006ea\u006d\u0065:\u0020\u0028\u0025\u0063\u0029",_egb [0]);
};}else {if _bf .IsWhiteSpace (_egb [0]){break ;}else if (_egb [0]=='/')||(_egb [0]=='[')||(_egb [0]=='(')||(_egb [0]==']')||(_egb [0]=='<')||(_egb [0]=='>'){break ;}else if _egb [0]=='#'{_bbd ,_ce :=_dbf ._dd .Peek (3);if _ce !=nil {return _bf .PdfObjectName (_eae .String ()),_ce ;
};_dbf ._dd .Discard (3);_dbe ,_ce :=_ec .DecodeString (string (_bbd [1:3]));if _ce !=nil {return _bf .PdfObjectName (_eae .String ()),_ce ;};_eae .Write (_dbe );}else {_gaa ,_ :=_dbf ._dd .ReadByte ();_eae .WriteByte (_gaa );};};};return _bf .PdfObjectName (_eae .String ()),nil ;
};func (_bgg *fdfParser )getFileOffset ()int64 {_cbe ,_ :=_bgg ._ae .Seek (0,_b .SeekCurrent );_cbe -=int64 (_bgg ._dd .Buffered ());return _cbe ;};func (_gbba *fdfParser )parseHexString ()(*_bf .PdfObjectString ,error ){_gbba ._dd .ReadByte ();var _adb _gf .Buffer ;
for {_aba ,_fc :=_gbba ._dd .Peek (1);if _fc !=nil {return _bf .MakeHexString (""),_fc ;};if _aba [0]=='>'{_gbba ._dd .ReadByte ();break ;};_cee ,_ :=_gbba ._dd .ReadByte ();if !_bf .IsWhiteSpace (_cee ){_adb .WriteByte (_cee );};};if _adb .Len ()%2==1{_adb .WriteRune ('0');
};_dfa ,_cf :=_ec .DecodeString (_adb .String ());if _cf !=nil {_cgg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020\u0050\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0068\u0065\u0078\u0020\u0073\u0074r\u0069\u006e\u0067\u003a\u0020\u0027\u0025\u0073\u0027 \u002d\u0020\u0072\u0065\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u0061n\u0020\u0065\u006d\u0070\u0074\u0079 \u0073\u0074\u0072i\u006e\u0067",_adb .String ());
return _bf .MakeHexString (""),nil ;};return _bf .MakeHexString (string (_dfa )),nil ;};var _df =_cd .MustCompile ("\u005e\u005b\u005c+-\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e]\u002b)\u0065[\u005c+\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e\u005d\u002b\u0029");
var _fea =_cd .MustCompile ("^\u005c\u0073\u002a\u0028\\d\u002b)\u005c\u0073\u002b\u0028\u005cd\u002b\u0029\u005c\u0073\u002b\u0052");func (_aef *fdfParser )parseFdfVersion ()(int ,int ,error ){_aef ._ae .Seek (0,_b .SeekStart );_gbf :=20;_adg :=make ([]byte ,_gbf );
_aef ._ae .Read (_adg );_ecb :=_bdf .FindStringSubmatch (string (_adg ));if len (_ecb )< 3{_dca ,_dcab ,_bec :=_aef .seekFdfVersionTopDown ();if _bec !=nil {_cgg .Log .Debug ("F\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065\u0063\u006f\u0076\u0065\u0072\u0079\u0020\u002d\u0020\u0075n\u0061\u0062\u006c\u0065\u0020\u0074\u006f\u0020\u0066\u0069nd\u0020\u0076\u0065r\u0073i\u006f\u006e");
return 0,0,_bec ;};return _dca ,_dcab ,nil ;};_fae ,_gbfd :=_d .Atoi (_ecb [1]);if _gbfd !=nil {return 0,0,_gbfd ;};_cgdd ,_gbfd :=_d .Atoi (_ecb [2]);if _gbfd !=nil {return 0,0,_gbfd ;};_cgg .Log .Debug ("\u0046\u0064\u0066\u0020\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020%\u0064\u002e\u0025\u0064",_fae ,_cgdd );
return _fae ,_cgdd ,nil ;};func (_feb *fdfParser )parseNumber ()(_bf .PdfObject ,error ){return _bf .ParseNumber (_feb ._dd )};type fdfParser struct{_fbf int ;_ff int ;_ffg map[int64 ]_bf .PdfObject ;_ae _b .ReadSeeker ;_dd *_f .Reader ;_dfd int64 ;_gg *_bf .PdfObjectDictionary ;
};func _cfcg (_fda _b .ReadSeeker )(*fdfParser ,error ){_eec :=&fdfParser {};_eec ._ae =_fda ;_eec ._ffg =map[int64 ]_bf .PdfObject {};_bag ,_cfcb ,_cggf :=_eec .parseFdfVersion ();if _cggf !=nil {_cgg .Log .Error ("U\u006e\u0061\u0062\u006c\u0065\u0020t\u006f\u0020\u0070\u0061\u0072\u0073\u0065\u0020\u0076e\u0072\u0073\u0069o\u006e:\u0020\u0025\u0076",_cggf );
return nil ,_cggf ;};_eec ._fbf =_bag ;_eec ._ff =_cfcb ;_cggf =_eec .parse ();return _eec ,_cggf ;};func (_gggd *fdfParser )parseDict ()(*_bf .PdfObjectDictionary ,error ){_cgg .Log .Trace ("\u0052\u0065\u0061\u0064\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020D\u0069\u0063\u0074\u0021");
_afe :=_bf .MakeDict ();_cbd ,_ :=_gggd ._dd .ReadByte ();if _cbd !='<'{return nil ,_e .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");};_cbd ,_ =_gggd ._dd .ReadByte ();if _cbd !='<'{return nil ,_e .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");
};for {_gggd .skipSpaces ();_gggd .skipComments ();_cccbc ,_bgb :=_gggd ._dd .Peek (2);if _bgb !=nil {return nil ,_bgb ;};_cgg .Log .Trace ("D\u0069c\u0074\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_cccbc ),string (_cccbc ));
if (_cccbc [0]=='>')&&(_cccbc [1]=='>'){_cgg .Log .Trace ("\u0045\u004f\u0046\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");_gggd ._dd .ReadByte ();_gggd ._dd .ReadByte ();break ;};_cgg .Log .Trace ("\u0050a\u0072s\u0065\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0021");
_bcf ,_bgb :=_gggd .parseName ();_cgg .Log .Trace ("\u004be\u0079\u003a\u0020\u0025\u0073",_bcf );if _bgb !=nil {_cgg .Log .Debug ("E\u0052\u0052\u004f\u0052\u0020\u0052e\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u006ea\u006d\u0065\u0020e\u0072r\u0020\u0025\u0073",_bgb );
return nil ,_bgb ;};if len (_bcf )> 4&&_bcf [len (_bcf )-4:]=="\u006e\u0075\u006c\u006c"{_bcc :=_bcf [0:len (_bcf )-4];_cgg .Log .Debug ("\u0054\u0061\u006b\u0069n\u0067\u0020\u0063\u0061\u0072\u0065\u0020\u006f\u0066\u0020n\u0075l\u006c\u0020\u0062\u0075\u0067\u0020\u0028%\u0073\u0029",_bcf );
_cgg .Log .Debug ("\u004e\u0065\u0077\u0020ke\u0079\u0020\u0022\u0025\u0073\u0022\u0020\u003d\u0020\u006e\u0075\u006c\u006c",_bcc );_gggd .skipSpaces ();_afda ,_ :=_gggd ._dd .Peek (1);if _afda [0]=='/'{_afe .Set (_bcc ,_bf .MakeNull ());continue ;};};
_gggd .skipSpaces ();_dea ,_bgb :=_gggd .parseObject ();if _bgb !=nil {return nil ,_bgb ;};_afe .Set (_bcf ,_dea );_cgg .Log .Trace ("\u0064\u0069\u0063\u0074\u005b\u0025\u0073\u005d\u0020\u003d\u0020\u0025\u0073",_bcf ,_dea .String ());};_cgg .Log .Trace ("\u0072\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020\u0044\u0069\u0063\u0074\u0021");
return _afe ,nil ;};func (_fcf *fdfParser )seekToEOFMarker (_bcbc int64 )error {_gef :=int64 (0);_dbb :=int64 (1000);for _gef < _bcbc {if _bcbc <=(_dbb +_gef ){_dbb =_bcbc -_gef ;};_ ,_edgb :=_fcf ._ae .Seek (-_gef -_dbb ,_b .SeekEnd );if _edgb !=nil {return _edgb ;
};_bfcc :=make ([]byte ,_dbb );_fcf ._ae .Read (_bfcc );_cgg .Log .Trace ("\u004c\u006f\u006f\u006bi\u006e\u0067\u0020\u0066\u006f\u0072\u0020\u0045\u004f\u0046 \u006da\u0072\u006b\u0065\u0072\u003a\u0020\u0022%\u0073\u0022",string (_bfcc ));_bbfcg :=_bbf .FindAllStringIndex (string (_bfcc ),-1);
if _bbfcg !=nil {_cdbd :=_bbfcg [len (_bbfcg )-1];_cgg .Log .Trace ("\u0049\u006e\u0064\u003a\u0020\u0025\u0020\u0064",_bbfcg );_fcf ._ae .Seek (-_gef -_dbb +int64 (_cdbd [0]),_b .SeekEnd );return nil ;};_cgg .Log .Debug ("\u0057\u0061\u0072\u006e\u0069\u006eg\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006b\u0065\u0072\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075n\u0064\u0021\u0020\u002d\u0020\u0063\u006f\u006e\u0074\u0069\u006e\u0075\u0065\u0020s\u0065e\u006b\u0069\u006e\u0067");
_gef +=_dbb ;};_cgg .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006be\u0072 \u0077\u0061\u0073\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064\u002e");return _e .New ("\u0045\u004f\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");
};func (_feag *fdfParser )parseNull ()(_bf .PdfObjectNull ,error ){_ ,_eca :=_feag ._dd .Discard (4);return _bf .PdfObjectNull {},_eca ;};

// Data represents forms data format (FDF) file data.
type Data struct{_af *_bf .PdfObjectDictionary ;_ag *_bf .PdfObjectArray ;};func (_ea *fdfParser )skipComments ()error {if _ ,_gfd :=_ea .skipSpaces ();_gfd !=nil {return _gfd ;};_gaf :=true ;for {_dgf ,_ead :=_ea ._dd .Peek (1);if _ead !=nil {_cgg .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_ead .Error ());
return _ead ;};if _gaf &&_dgf [0]!='%'{return nil ;};_gaf =false ;if (_dgf [0]!='\r')&&(_dgf [0]!='\n'){_ea ._dd .ReadByte ();}else {break ;};};return _ea .skipComments ();};func (_bggf *fdfParser )parse ()error {_bggf ._ae .Seek (0,_b .SeekStart );_bggf ._dd =_f .NewReader (_bggf ._ae );
for {_bggf .skipComments ();_ade ,_dfbc :=_bggf ._dd .Peek (20);if _dfbc !=nil {_cgg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");
return _dfbc ;};if _c .HasPrefix (string (_ade ),"\u0074r\u0061\u0069\u006c\u0065\u0072"){_bggf ._dd .Discard (7);_bggf .skipSpaces ();_bggf .skipComments ();_ccf ,_ :=_bggf .parseDict ();_bggf ._gg =_ccf ;break ;};_bba :=_bce .FindStringSubmatchIndex (string (_ade ));
if len (_bba )< 6{_cgg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_ade ));
return _e .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_ecf ,_dfbc :=_bggf .parseIndirectObject ();if _dfbc !=nil {return _dfbc ;};switch _efa :=_ecf .(type ){case *_bf .PdfIndirectObject :_bggf ._ffg [_efa .ObjectNumber ]=_efa ;case *_bf .PdfObjectStream :_bggf ._ffg [_efa .ObjectNumber ]=_efa ;default:return _e .New ("\u0074\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");
};};return nil ;};

// Root returns the Root of the FDF document.
func (_adbg *fdfParser )Root ()(*_bf .PdfObjectDictionary ,error ){if _adbg ._gg !=nil {if _cfg ,_beef :=_adbg .trace (_adbg ._gg .Get ("\u0052\u006f\u006f\u0074")).(*_bf .PdfObjectDictionary );_beef {if _acc ,_dfb :=_adbg .trace (_cfg .Get ("\u0046\u0044\u0046")).(*_bf .PdfObjectDictionary );
_dfb {return _acc ,nil ;};};};var _eff []int64 ;for _feae :=range _adbg ._ffg {_eff =append (_eff ,_feae );};_a .Slice (_eff ,func (_ffa ,_def int )bool {return _eff [_ffa ]< _eff [_def ]});for _ ,_cfc :=range _eff {_beg :=_adbg ._ffg [_cfc ];if _dda ,_fbd :=_adbg .trace (_beg ).(*_bf .PdfObjectDictionary );
_fbd {if _ggd ,_begb :=_adbg .trace (_dda .Get ("\u0046\u0044\u0046")).(*_bf .PdfObjectDictionary );_begb {return _ggd ,nil ;};};};return nil ,_e .New ("\u0046\u0044\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");};func _bfca (_bbfe string )(*fdfParser ,error ){_fdb :=fdfParser {};
_fead :=[]byte (_bbfe );_fggg :=_gf .NewReader (_fead );_fdb ._ae =_fggg ;_fdb ._ffg =map[int64 ]_bf .PdfObject {};_aed :=_f .NewReader (_fggg );_fdb ._dd =_aed ;_fdb ._dfd =int64 (len (_bbfe ));return &_fdb ,_fdb .parse ();};

// FieldDictionaries returns a map of field names to field dictionaries.
func (fdf *Data )FieldDictionaries ()(map[string ]*_bf .PdfObjectDictionary ,error ){_fb :=map[string ]*_bf .PdfObjectDictionary {};for _gd :=0;_gd < fdf ._ag .Len ();_gd ++{_cdc ,_afd :=_bf .GetDict (fdf ._ag .Get (_gd ));if _afd {_ad ,_ :=_bf .GetString (_cdc .Get ("\u0054"));
if _ad !=nil {_fb [_ad .Str ()]=_cdc ;};};};return _fb ,nil ;};func (_fdg *fdfParser )readTextLine ()(string ,error ){var _gae _gf .Buffer ;for {_bbfc ,_agd :=_fdg ._dd .Peek (1);if _agd !=nil {_cgg .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_agd .Error ());
return _gae .String (),_agd ;};if (_bbfc [0]!='\r')&&(_bbfc [0]!='\n'){_gbb ,_ :=_fdg ._dd .ReadByte ();_gae .WriteByte (_gbb );}else {break ;};};return _gae .String (),nil ;};var _bce =_cd .MustCompile ("\u0028\u005c\u0064\u002b)\\\u0073\u002b\u0028\u005c\u0064\u002b\u0029\u005c\u0073\u002b\u006f\u0062\u006a");
func (_cbcb *fdfParser )parseString ()(*_bf .PdfObjectString ,error ){_cbcb ._dd .ReadByte ();var _cec _gf .Buffer ;_cdb :=1;for {_aac ,_ebd :=_cbcb ._dd .Peek (1);if _ebd !=nil {return _bf .MakeString (_cec .String ()),_ebd ;};if _aac [0]=='\\'{_cbcb ._dd .ReadByte ();
_baa ,_egba :=_cbcb ._dd .ReadByte ();if _egba !=nil {return _bf .MakeString (_cec .String ()),_egba ;};if _bf .IsOctalDigit (_baa ){_abc ,_bcb :=_cbcb ._dd .Peek (2);if _bcb !=nil {return _bf .MakeString (_cec .String ()),_bcb ;};var _bfae []byte ;_bfae =append (_bfae ,_baa );
for _ ,_bed :=range _abc {if _bf .IsOctalDigit (_bed ){_bfae =append (_bfae ,_bed );}else {break ;};};_cbcb ._dd .Discard (len (_bfae )-1);_cgg .Log .Trace ("\u004e\u0075\u006d\u0065ri\u0063\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0020\u0022\u0025\u0073\u0022",_bfae );
_aea ,_bcb :=_d .ParseUint (string (_bfae ),8,32);if _bcb !=nil {return _bf .MakeString (_cec .String ()),_bcb ;};_cec .WriteByte (byte (_aea ));continue ;};switch _baa {case 'n':_cec .WriteRune ('\n');case 'r':_cec .WriteRune ('\r');case 't':_cec .WriteRune ('\t');
case 'b':_cec .WriteRune ('\b');case 'f':_cec .WriteRune ('\f');case '(':_cec .WriteRune ('(');case ')':_cec .WriteRune (')');case '\\':_cec .WriteRune ('\\');};continue ;}else if _aac [0]=='('{_cdb ++;}else if _aac [0]==')'{_cdb --;if _cdb ==0{_cbcb ._dd .ReadByte ();
break ;};};_afdb ,_ :=_cbcb ._dd .ReadByte ();_cec .WriteByte (_afdb );};return _bf .MakeString (_cec .String ()),nil ;};func (_afc *fdfParser )setFileOffset (_eg int64 ){_afc ._ae .Seek (_eg ,_b .SeekStart );_afc ._dd =_f .NewReader (_afc ._ae );};func (_bde *fdfParser )parseIndirectObject ()(_bf .PdfObject ,error ){_degb :=_bf .PdfIndirectObject {};
_cgg .Log .Trace ("\u002dR\u0065a\u0064\u0020\u0069\u006e\u0064i\u0072\u0065c\u0074\u0020\u006f\u0062\u006a");_fed ,_ddcb :=_bde ._dd .Peek (20);if _ddcb !=nil {_cgg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");
return &_degb ,_ddcb ;};_cgg .Log .Trace ("\u0028\u0069\u006edi\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0020\u0070\u0065\u0065\u006b\u0020\u0022\u0025\u0073\u0022",string (_fed ));_ccb :=_bce .FindStringSubmatchIndex (string (_fed ));if len (_ccb )< 6{_cgg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_fed ));
return &_degb ,_e .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_bde ._dd .Discard (_ccb [0]);_cgg .Log .Trace ("O\u0066\u0066\u0073\u0065\u0074\u0073\u0020\u0025\u0020\u0064",_ccb );_daa :=_ccb [1]-_ccb [0];_eggg :=make ([]byte ,_daa );_ ,_ddcb =_bde .readAtLeast (_eggg ,_daa );if _ddcb !=nil {_cgg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0075\u006e\u0061\u0062l\u0065\u0020\u0074\u006f\u0020\u0072\u0065\u0061\u0064\u0020-\u0020\u0025\u0073",_ddcb );
return nil ,_ddcb ;};_cgg .Log .Trace ("\u0074\u0065\u0078t\u006c\u0069\u006e\u0065\u003a\u0020\u0025\u0073",_eggg );_dgd :=_bce .FindStringSubmatch (string (_eggg ));if len (_dgd )< 3{_cgg .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_eggg ));
return &_degb ,_e .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_ddfg ,_ :=_d .Atoi (_dgd [1]);_geed ,_ :=_d .Atoi (_dgd [2]);_degb .ObjectNumber =int64 (_ddfg );_degb .GenerationNumber =int64 (_geed );for {_ddb ,_bab :=_bde ._dd .Peek (2);if _bab !=nil {return &_degb ,_bab ;};_cgg .Log .Trace ("I\u006ed\u002e\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_ddb ),string (_ddb ));
if _bf .IsWhiteSpace (_ddb [0]){_bde .skipSpaces ();}else if _ddb [0]=='%'{_bde .skipComments ();}else if (_ddb [0]=='<')&&(_ddb [1]=='<'){_cgg .Log .Trace ("\u0043\u0061\u006c\u006c\u0020\u0050\u0061\u0072\u0073e\u0044\u0069\u0063\u0074");_degb .PdfObject ,_bab =_bde .parseDict ();
_cgg .Log .Trace ("\u0045\u004f\u0046\u0020Ca\u006c\u006c\u0020\u0050\u0061\u0072\u0073\u0065\u0044\u0069\u0063\u0074\u003a\u0020%\u0076",_bab );if _bab !=nil {return &_degb ,_bab ;};_cgg .Log .Trace ("\u0050\u0061\u0072\u0073\u0065\u0064\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002e.\u002e\u0020\u0066\u0069\u006e\u0069\u0073\u0068\u0065\u0064\u002e");
}else if (_ddb [0]=='/')||(_ddb [0]=='(')||(_ddb [0]=='[')||(_ddb [0]=='<'){_degb .PdfObject ,_bab =_bde .parseObject ();if _bab !=nil {return &_degb ,_bab ;};_cgg .Log .Trace ("P\u0061\u0072\u0073\u0065\u0064\u0020o\u0062\u006a\u0065\u0063\u0074\u0020\u002e\u002e\u002e \u0066\u0069\u006ei\u0073h\u0065\u0064\u002e");
}else {if _ddb [0]=='e'{_gcd ,_cgc :=_bde .readTextLine ();if _cgc !=nil {return nil ,_cgc ;};if len (_gcd )>=6&&_gcd [0:6]=="\u0065\u006e\u0064\u006f\u0062\u006a"{break ;};}else if _ddb [0]=='s'{_ddb ,_ =_bde ._dd .Peek (10);if string (_ddb [:6])=="\u0073\u0074\u0072\u0065\u0061\u006d"{_adc :=6;
if len (_ddb )> 6{if _bf .IsWhiteSpace (_ddb [_adc ])&&_ddb [_adc ]!='\r'&&_ddb [_adc ]!='\n'{_cgg .Log .Debug ("\u004e\u006fn\u002d\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0074\u0020\u0046\u0044\u0046\u0020\u006e\u006f\u0074 \u0065\u006e\u0064\u0069\u006e\u0067 \u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006c\u0069\u006e\u0065\u0020\u0070\u0072o\u0070\u0065r\u006c\u0079\u0020\u0077i\u0074\u0068\u0020\u0045\u004fL\u0020\u006d\u0061\u0072\u006b\u0065\u0072");
_adc ++;};if _ddb [_adc ]=='\r'{_adc ++;if _ddb [_adc ]=='\n'{_adc ++;};}else if _ddb [_adc ]=='\n'{_adc ++;};};_bde ._dd .Discard (_adc );_gcg ,_afdc :=_degb .PdfObject .(*_bf .PdfObjectDictionary );if !_afdc {return nil ,_e .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006di\u0073s\u0069\u006e\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079");
};_cgg .Log .Trace ("\u0053\u0074\u0072\u0065\u0061\u006d\u0020\u0064\u0069c\u0074\u0020\u0025\u0073",_gcg );_gfe ,_eeb :=_gcg .Get ("\u004c\u0065\u006e\u0067\u0074\u0068").(*_bf .PdfObjectInteger );if !_eeb {return nil ,_e .New ("\u0073\u0074re\u0061\u006d\u0020l\u0065\u006e\u0067\u0074h n\u0065ed\u0073\u0020\u0074\u006f\u0020\u0062\u0065 a\u006e\u0020\u0069\u006e\u0074\u0065\u0067e\u0072");
};_beda :=*_gfe ;if _beda < 0{return nil ,_e .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006e\u0065\u0065\u0064\u0073\u0020\u0074\u006f \u0062e\u0020\u006c\u006f\u006e\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0030");};if int64 (_beda )> _bde ._dfd {_cgg .Log .Debug ("\u0045\u0052R\u004f\u0052\u003a\u0020\u0053t\u0072\u0065\u0061\u006d\u0020l\u0065\u006e\u0067\u0074\u0068\u0020\u0063\u0061\u006e\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u006c\u0061\u0072\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0069\u007a\u0065");
return nil ,_e .New ("\u0069n\u0076\u0061l\u0069\u0064\u0020\u0073t\u0072\u0065\u0061m\u0020\u006c\u0065\u006e\u0067\u0074\u0068\u002c\u0020la\u0072\u0067\u0065r\u0020\u0074h\u0061\u006e\u0020\u0066\u0069\u006ce\u0020\u0073i\u007a\u0065");};_ecgb :=make ([]byte ,_beda );
_ ,_bab =_bde .readAtLeast (_ecgb ,int (_beda ));if _bab !=nil {_cgg .Log .Debug ("E\u0052\u0052\u004f\u0052 s\u0074r\u0065\u0061\u006d\u0020\u0028%\u0064\u0029\u003a\u0020\u0025\u0058",len (_ecgb ),_ecgb );_cgg .Log .Debug ("\u0045R\u0052\u004f\u0052\u003a\u0020\u0025v",_bab );
return nil ,_bab ;};_faa :=_bf .PdfObjectStream {};_faa .Stream =_ecgb ;_faa .PdfObjectDictionary =_degb .PdfObject .(*_bf .PdfObjectDictionary );_faa .ObjectNumber =_degb .ObjectNumber ;_faa .GenerationNumber =_degb .GenerationNumber ;_bde .skipSpaces ();
_bde ._dd .Discard (9);_bde .skipSpaces ();return &_faa ,nil ;};};_degb .PdfObject ,_bab =_bde .parseObject ();return &_degb ,_bab ;};};_cgg .Log .Trace ("\u0052\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0021");
return &_degb ,nil ;};func (_faeg *fdfParser )seekFdfVersionTopDown ()(int ,int ,error ){_faeg ._ae .Seek (0,_b .SeekStart );_faeg ._dd =_f .NewReader (_faeg ._ae );_ceg :=20;_gac :=make ([]byte ,_ceg );for {_egaf ,_afcb :=_faeg ._dd .ReadByte ();if _afcb !=nil {if _afcb ==_b .EOF {break ;
}else {return 0,0,_afcb ;};};if _bf .IsDecimalDigit (_egaf )&&_gac [_ceg -1]=='.'&&_bf .IsDecimalDigit (_gac [_ceg -2])&&_gac [_ceg -3]=='-'&&_gac [_ceg -4]=='F'&&_gac [_ceg -5]=='D'&&_gac [_ceg -6]=='P'{_edc :=int (_gac [_ceg -2]-'0');_gabb :=int (_egaf -'0');
return _edc ,_gabb ,nil ;};_gac =append (_gac [1:_ceg ],_egaf );};return 0,0,_e .New ("\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};func (_egad *fdfParser )trace (_dga _bf .PdfObject )_bf .PdfObject {switch _gab :=_dga .(type ){case *_bf .PdfObjectReference :_fec ,_fdaa :=_egad ._ffg [_gab .ObjectNumber ].(*_bf .PdfIndirectObject );
if _fdaa {return _fec .PdfObject ;};_cgg .Log .Debug ("\u0054\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");return nil ;case *_bf .PdfIndirectObject :return _gab .PdfObject ;};return _dga ;};func (_bea *fdfParser )parseObject ()(_bf .PdfObject ,error ){_cgg .Log .Trace ("\u0052e\u0061d\u0020\u0064\u0069\u0072\u0065c\u0074\u0020o\u0062\u006a\u0065\u0063\u0074");
_bea .skipSpaces ();for {_aab ,_gggb :=_bea ._dd .Peek (2);if _gggb !=nil {return nil ,_gggb ;};_cgg .Log .Trace ("\u0050e\u0065k\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u003a\u0020\u0025\u0073",string (_aab ));if _aab [0]=='/'{_ddc ,_fgg :=_bea .parseName ();
_cgg .Log .Trace ("\u002d\u003e\u004ea\u006d\u0065\u003a\u0020\u0027\u0025\u0073\u0027",_ddc );return &_ddc ,_fgg ;}else if _aab [0]=='('{_cgg .Log .Trace ("\u002d>\u0053\u0074\u0072\u0069\u006e\u0067!");return _bea .parseString ();}else if _aab [0]=='['{_cgg .Log .Trace ("\u002d\u003e\u0041\u0072\u0072\u0061\u0079\u0021");
return _bea .parseArray ();}else if (_aab [0]=='<')&&(_aab [1]=='<'){_cgg .Log .Trace ("\u002d>\u0044\u0069\u0063\u0074\u0021");return _bea .parseDict ();}else if _aab [0]=='<'{_cgg .Log .Trace ("\u002d\u003e\u0048\u0065\u0078\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0021");
return _bea .parseHexString ();}else if _aab [0]=='%'{_bea .readComment ();_bea .skipSpaces ();}else {_cgg .Log .Trace ("\u002d\u003eN\u0075\u006d\u0062e\u0072\u0020\u006f\u0072\u0020\u0072\u0065\u0066\u003f");_aab ,_ =_bea ._dd .Peek (15);_edf :=string (_aab );
_cgg .Log .Trace ("\u0050\u0065\u0065k\u0020\u0073\u0074\u0072\u003a\u0020\u0025\u0073",_edf );if (len (_edf )> 3)&&(_edf [:4]=="\u006e\u0075\u006c\u006c"){_fgf ,_abag :=_bea .parseNull ();return &_fgf ,_abag ;}else if (len (_edf )> 4)&&(_edf [:5]=="\u0066\u0061\u006cs\u0065"){_egg ,_cag :=_bea .parseBool ();
return &_egg ,_cag ;}else if (len (_edf )> 3)&&(_edf [:4]=="\u0074\u0072\u0075\u0065"){_ddf ,_bad :=_bea .parseBool ();return &_ddf ,_bad ;};_edg :=_fea .FindStringSubmatch (_edf );if len (_edg )> 1{_aab ,_ =_bea ._dd .ReadBytes ('R');_cgg .Log .Trace ("\u002d\u003e\u0020\u0021\u0052\u0065\u0066\u003a\u0020\u0027\u0025\u0073\u0027",string (_aab [:]));
_aabc ,_ceb :=_bdd (string (_aab ));return &_aabc ,_ceb ;};_dad :=_dc .FindStringSubmatch (_edf );if len (_dad )> 1{_cgg .Log .Trace ("\u002d\u003e\u0020\u004e\u0075\u006d\u0062\u0065\u0072\u0021");return _bea .parseNumber ();};_dad =_df .FindStringSubmatch (_edf );
if len (_dad )> 1{_cgg .Log .Trace ("\u002d\u003e\u0020\u0045xp\u006f\u006e\u0065\u006e\u0074\u0069\u0061\u006c\u0020\u004e\u0075\u006d\u0062\u0065r\u0021");_cgg .Log .Trace ("\u0025\u0020\u0073",_dad );return _bea .parseNumber ();};_cgg .Log .Debug ("\u0045R\u0052\u004f\u0052\u0020U\u006e\u006b\u006e\u006f\u0077n\u0020(\u0070e\u0065\u006b\u0020\u0022\u0025\u0073\u0022)",_edf );
return nil ,_e .New ("\u006f\u0062\u006a\u0065\u0063t\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0065\u0072\u0072\u006fr\u0020\u002d\u0020\u0075\u006e\u0065\u0078\u0070\u0065\u0063\u0074\u0065\u0064\u0020\u0070\u0061\u0074\u0074\u0065\u0072\u006e");
};};};